package com.totopia.server.modules.user.repository;

import com.totopia.server.modules.user.entity.UserEntity;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Optional;

import static org.junit.Assert.assertEquals;

@Ignore
@RunWith(SpringRunner.class)
@SpringBootTest
public class UserRepositoryTest {

    @Autowired
    private UserRepository userRepository;

    // private User.UserBuilder user;

    private List<UserEntity> userList = new ArrayList<>();

    @Before
    public void setUp() throws Exception {
        UserEntity user = UserEntity.builder().activation("Y").block(false).email("geekdev@naver.com").nickname("admin")
                .otep("").otpKey("").password("qwer5795").username("admin").requireReset(false)
                .resetCount(Long.valueOf(0)).lastResetTime(new Date()).build();

        userList.add(user);

        user = UserEntity.builder().activation("Y").block(false).email("geektest1@naver.com").nickname("test1").otep("")
                .otpKey("").password("qwer5795").username("test1").requireReset(false).resetCount(Long.valueOf(0))
                .lastResetTime(new Date()).build();

        userList.add(user);

        user = UserEntity.builder().activation("Y").block(false).email("geektest2@naver.com").nickname("test2").otep("")
                .otpKey("").password("qwer5795").username("test2").requireReset(false).resetCount(Long.valueOf(0))
                .lastResetTime(new Date()).build();

        userList.add(user);
    }

    @Test
    public void findByUsername() {
        UserEntity admin = this.getAdmin().orElse(null);
        if (admin == null) {
            this.userRepository.saveAll(userList);
            assertEquals("Equlas", userList.get(0).getNickname(), "admin");
        }
    }

    @Test
    public void findByEmail() {
        UserEntity admin = this.getAdmin().orElse(null);

        if (admin != null) {

        }
    }

    @Test
    public void findAllByNickname() {
    }

    @Test
    public void findAllByBlockTrue() {
    }

    @Test
    public void findAllByBlockFalse() {
    }

    @Test
    public void findAllByIsAdminTrue() {
    }

    @Test
    public void findAllByRequireResetTrue() {
    }

    @Test
    public void findAllByIsAdminFalseAndActivationEquals() {
    }

    @Test
    public void findAllByRegisterDateBetween() {
    }

    @Test
    public void findAllByLastvisitDateBetween() {
    }

    @Test
    public void findAllByLastResetTimeBetween() {
    }

    @Test
    public void countByRegisterDateGreaterThanEqual() {
    }

    private Optional<UserEntity> getAdmin() {
        try {
            return this.userRepository.findByUsername("admin");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
}